#include "netshell.h"

static void term_handler (int sig) {
	shut_down();
}

/* This sets up the program to run as a friendly daemon, something
   like a 'rig for silent runnning' function. ;) */
void daemonize(void)
{
	int i;

	for (i = 0; i < NOFILE; i++)	/* close open file descriptors */
		close(i);
	chdir(DAEMONDIRECTORY);		/* change to our directory */
	if (fork())
		exit(0);		/* put self in background */
	setsid();			/* make self process-group leader */
	signal(SIGTTOU, SIG_IGN);	/* ignore all job-control signals, */
	signal(SIGTTIN, SIG_IGN);	/* SIGHUP, and SIGCLD */
	signal(SIGTSTP, SIG_IGN);
#ifdef SIGCLD
	signal(SIGCLD, SIG_IGN);
#endif
	signal(SIGHUP, SIG_IGN);
	signal(SIGTERM, term_handler);
	if (fork())
		exit(0);	/* and dissociate from terminal */
	nice(5);		/* be nice to your system */
	user_startup();		/* do any additional user-specified startup */
}
